'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Field = require('./_Field');

var _Field2 = _interopRequireDefault(_Field);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Key extends _Field2.default {
  constructor(name) {
    super(name);
    this.isAuto = false; // Does the key needs to be automatically generated
    this.keyType = _Field.HASH; // The type of the key either hash (partition) or range (sort)
  }

  sort() {
    if (this.isAuto) {
      // throw new Error(`Key ${this.name} can't have auto and sort field set`);
    }

    this.keyType = _Field.RANGE;
    return this;
  }

  auto() {
    if (this.keyType !== _Field.HASH) {
      // throw new Error(`Key ${this.name} can't have auto and sort field set`);
    }
    this.isAuto = true;
    return this;
  }
}

exports.default = Key;