'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = insert;

var _shortid = require('shortid');

var _shortid2 = _interopRequireDefault(_shortid);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function insert(db, name, { keys, pKey }, allowUpdate = false) {
  const params = {
    TableName: name
  };

  if (!allowUpdate) {
    params.ExpressionAttributeNames = {};
    params.ConditionExpression = keys.map(k => {
      const f = `#${k.name}`;
      params.ExpressionAttributeNames[f] = k.name;
      return `attribute_not_exists(${f})`;
    }).join(' AND ');
  }

  return record => {
    if (pKey.isAuto && !record[pKey.name]) {
      // eslint-disable-next-line no-param-reassign
      record[pKey.name] = (0, _shortid2.default)();
    }
    const pid = record[pKey.name];

    params.Item = record;
    // TODO: Check for condition expression failure, specially when key is auto generated
    return db.put(params).promise().then(() => pid);
  };
}